     subroutine th_22indexRELAXsad(isubthe,icase,iput,iget,info) 
!    sad= source,absorber,detector : lstr1case=1,2,3 (comthe.for)      
       use glbconst, only: maxfr1,maxfr2,maxthss,maxscrd,icstrf,ivstrf,nwr
     use comthe, only: array_fr,theoryname,mLG,ifrcase,lstr1case
     implicit none 
     integer, intent(inout):: isubthe   
     integer, intent(in)   :: icase,iput,iget
     integer, intent(out)  :: info      
                                                                       
      integer,parameter::istr=38+4*(maxfr1+maxfr2)+3*maxthss 
      integer       dstr,iposLG,iadd                                          
      common/struct/dstr(istr+1),iposLG,iadd(6)

      integer       ibe,jpolsource,jpolabsorber,iflag_basis,idum,    &
                    nLG,nAS,nSC,idum2,ak8,sk8,ien
      real          srw8 
      common/strLOC/jpolsource,jpolabsorber,ibe(10),iflag_basis,     &
                    idum,nLG,nAS,nSC,idum2,ak8,sk8,srw8,ien(11)      

     logical       b_vsp,b_v_max,b_dumvsp 
     common/bvstrf/b_vsp(4),b_v_max,b_dumvsp(ivstrf-5) 
                                                                       
!    storage use nst2_8 for 4 complex numbers of r_ik                  
     real          c1,gamnat,e_xsi,flag_SAMP,flag_Voigt,offset,dumc 
     common/acmaps/c1,gamnat,e_xsi,flag_SAMP,flag_Voigt,offset,dumc(icstrf-6) 
     real          avm,sftr,aisom,w_Gauss,wLorentz,dumv 
     logical       b_vm,b_sftr,b_isom,b_w_Gauss,b_wLorentz,b_dumv 
     common/avmaps/avm,sftr,aisom,w_Gauss,wLorentz(8),dumv(ivstrf-12) 
     common/bvmaps/b_vm,b_sftr,b_isom,b_w_Gauss,b_wLorentz(8),           &
                   b_dumv(ivstrf-12)                                    
                                                                       
                                                                       
     logical   b_pc
     integer   nE,iflag_SAMP,iflag_Voigt,jges,jn,ip,      &
               i,n,ni,nget,nall,n_all,nst      
     real      Eagd,w_Lorentz,gamma,srw
     complex   fp1p1,fm1m1,fm1p1,fp1m1,rtr,dtr,hc,hci
     complex, dimension(:), allocatable :: cLG

     if(isubthe.lt.0) then
       theoryname='2x2_ref_index_dynamic_sad    v=160' 
       if(ifrcase.le.4) then 
!        i=2 
!        if(jpolsource.eq.1) i=4 
!        if(-isubthe.eq.1) then 
!         c1=i*(nSC+1)+1 
!        end if 
        if(-isubthe.eq.2) then 
         c1=8*(nAS+1) 
!        if(-isubthe.eq.3) c1=i*(nSC+1) 
        end if 
       end if

       if(ifrcase.eq.5) then 
        c1=2*(nAS+1) 
        if(jpolabsorber.eq.1) c1=c1*4 
       end if
       return 
      end if 
!       write(6,'(a,6f10.2)')'th_22refindexf avm,sftr,aisom,w_Gauss,w_Lorentz=',& 
!                      avm,sftr,aisom,w_Gauss,w_Lorentz               
                                                                        
      hci=cmplx(0.,1.) 
      iflag_SAMP=flag_SAMP 
      iflag_Voigt=flag_Voigt 
      nst=4 
                                                                        
      call get_theory(isubthe,info) 
      if(info.gt.0) return 
!       write(6,'(a,5f10.4,/,50x,5l5)')                                 
!     &  'th_22refindexf avm,sftr,aisom,w_Gauss,w_Lorentz=',            
!     &                  avm,sftr,aisom,w_Gauss,w_Lorentz,              
!     &             b_vm,b_sftr,b_isom,b_w_Gauss,b_w_Lorentz            
                                                                        
      b_pc=b_v_max.or.b_isom.or.b_w_Gauss.or.isubthe.gt.0 
      do i=1,8
       b_pc=b_pc.or.b_wLorentz(i)
      end do
      if(.not.b_pc.or.info.gt.0) then 
       isubthe=-abs(isubthe) 
       goto 400 
      else 
        isubthe=abs(isubthe) 
      end if 
                                                                        
      nget=real(array_fr(iget+1))+2
      n_all=real(array_fr(nget-1))           ! nput+2 in gpg_22nuclearRelax
      jges=aimag(array_fr(nget-1)) 
                                                                        
!      write(6,'(a,8i8)')&
!      '  refindexRELAX iget,nget,iput,lstr1case,jges,n_all=', &    
!              iget,nget,iput,lstr1case,jges,n_all                           

      goto (100,200,300),lstr1case 
!---------------------- source ------------------------------------     
  100 continue 
   print'(a)',' relaxation  theories are not expected for the source' 
  goto 400 
!------------------------ absorber ----------------------------------   
  200  continue 
!    write(6,'(a,5i6)') '2x2_ref n_all,icase,iflag_SAMP=',n_all,icase,iflag_SAMP,NAS                    

     
     do nall=1,n_all
      ip=nget+5*jges*(nall-1)      
      do jn=ip,ip+(jges-1)*5,5
       Eagd=real(array_fr(jn+1))+aisom 
       nE=ifix(Eagd/srw8+0.5)          ! nE <= sk8
       if (abs(nE).gt.ak8)&
       write(nwr,'(2(a,f10.4),a,i8)')              &
       '**** E(absorber)=',Eagd,' out of range ',ak8*srw8,'[mm/s]',jn+1   
      end do  ! jn=  
     end do   !  nall=1,n_all  

     do n=iput+1,iput+(nAS+1)*8 
       array_fr(n)=(0.,0.) 
      end do 
      w_Lorentz=wLorentz(1) 

     allocate(cLG(-nAS:nAS))

     srw=srw8*float(nst) 

     do nall=1,n_all
      ip=nget+5*jges*(nall-1)        
      do jn=ip,ip+(jges-1)*5,5 
       Eagd=real(array_fr(jn+1))+aisom
       gamma=gamnat-2*aimag(array_fr(jn+1))
       w_Lorentz=gamma/gamnat-1.
!      normalization of cLG(w_Lorentz*gamnat)

       call aLORGAU(Eagd,gamnat,e_xsi,srw,w_Lorentz,w_Gauss,iflag_Voigt,nAS,cLG)

       fp1p1=array_fr(jn+2)
        fm1m1=array_fr(jn+3)
        fp1m1=array_fr(jn+5)
        fm1p1=array_fr(jn+4)
        rtr=-(fp1p1+fm1m1)/2.*hci                  
        dtr=(fp1p1-fm1m1)/2.

!        write(6,'(i8,f10.4,a,8f11.6)')jn,Eagd,' rtr,dtr,mp=',real(rtr),aimag(dtr),fp1m1,fm1p1
!       write(6,'(a,8f10.3)')'w_Lorentz,Eagd,rtr=',w_Lorentz,Eagd,rtr
!       write(6,'(2a,/,5f10.4,5i8)')'gamnat,e_xsi,',                  
!   &   'srw8,w_Lorentz,w_Gauss,nLG,iflag_Voigt,iposLG=',        
!   &    gamnat,e_xsi,srw*250,w_Lorentz,w_Gauss,nAS,iflag_Voigt
        do n=0,nAS 
         ni=iput+8*n 
         hc=cLG(n)
         array_fr(ni+1)=array_fr(ni+1)-hc*rtr  
         array_fr(ni+2)=array_fr(ni+2)-hc*dtr  
         array_fr(ni+3)=array_fr(ni+3)-hc*fp1m1
         array_fr(ni+4)=array_fr(ni+4)-hc*fm1p1 
         hc=cLG(-n) 
         array_fr(ni+5)=array_fr(ni+5)-hc*rtr  
         array_fr(ni+6)=array_fr(ni+6)-hc*dtr   
         array_fr(ni+7)=array_fr(ni+7)-hc*fp1m1 
         array_fr(ni+8)=array_fr(ni+8)-hc*fm1p1 
        end do
      end do       !   jn=
    end do        ! nall=1,n_all
    deallocate(cLG)
    goto 400 
                                                                      
!------------------------------detector-----------------------------------   
  300  continue 
   print'(a)',' only scalar theories are expected' 
                                                                        
  400 return 
      END                                           

      
